<template>
  <div>
    <div class="d-flex justify-space-between">
      <div style="width: 100px;">
        <v-select
          v-model="perPage"
          :label="$t('totalVisible')"
          :items="listPerPage"
          @change="getRecepciones"
          dense
        />
      </div>
      <div class="d-flex justify-end">
        <v-btn
          class="mt-2 mr-4"
          color="success"
          rounded
          small
          @click="nuevaRecepcion"
          :disabled="loading"
        >
          <v-icon>mdi-table-plus</v-icon>
          {{ $t('nuevaRecepcion') }}
        </v-btn>
        <v-btn
          class="mt-2 mr-4"
          color="primary"
          rounded
          small
          @click="refreshTable"
          :disabled="loading"
        >
          <v-icon>mdi-refresh</v-icon>
          {{ $t('actualizar') }}
        </v-btn>
        <v-pagination
          v-model="currentPage"
          :disabled="loading"
          :length="lastPage"
          :total-visible="5"
        />
      </div>
    </div>
    <v-data-table
      v-model="selected"
      :headers="headers"
      :items="recepcionesData"
      item-key="id"
      class="elevation-1"
      disable-pagination
      hide-default-footer
      dense
      :loading="loading"
      :single-expand="singleExpand"
      show-expand
    >
      <template v-slot:expanded-item="{ headers, item }">
        <td :colspan="headers.length">
          <SubDetalleRecepcion :items="item.detalle_recepcion"/>
        </td>
      </template>
    </v-data-table>
  </div>
</template>

<script>
import RecepcionServicio from '@/store/services/RecepcionServicio'
import SubDetalleRecepcion from './SubDetalleRecepcion'
export default {
  name: "RecepcionesTabla",
  components: {
    SubDetalleRecepcion
  },
  data() {
    return {
      expanded: [],
      singleExpand: false,
      listPerPage: [5, 10, 50, this.$t('todo')],
      perPage: 50,
      lastPage: 0,
      total: 0,
      currentPage: 1,
      recepcionesData: [],
      selected: [],
      loading: false,
      colorEstado: 'success'
    }
  },
  methods: {
    verifyType(value) {
      return typeof value;
    },
    async getRecepciones() {
      this.loading = true;
      const params = {
        page: this.currentPage,
        order_by: 'created_at',
        order_direction: 'DESC',
        per_page:
          this.verifyType(this.perPage) === 'string'
            ? this.total
            : this.perPage,
      }
      try {
        let response = await RecepcionServicio.index(params)
        this.recepcionesData = response.data.data;
        this.currentPage = response.data.current_page;
        this.lastPage = response.data.last_page;
        this.total = response.data.total;
        this.loading = false;
      } catch (error) {
        this.loading = false;
        if (error.response.status !== 401) {
          console.log(error.response.message)
        }
      }
    },
    refreshTable() {
      this.resetCurrentPage();
    },
    resetCurrentPage() {
      if (this.currentPage === 1) this.getRecepciones();
      else this.currentPage = 1;
    },
    nuevaRecepcion() {
      this.$router.push('nueva-recepcion');
    },
  },
  computed: {
    headers() {
      return [
        {
          text: this.$t('codigo'),
          value: 'id',
          sortable: false,
        },
        {
          text: this.$t('usuario'),
          value: 'usuario.name',
          sortable: false,
        },
        {
          text: this.$t('area'),
          value: 'usuario.area',
          sortable: false,
        },
        {
          text: this.$t('factura'),
          value: 'factura',
          sortable: false,
        },
        {
          text: this.$t('fechaCompra'),
          value: 'fecha_compra',
          sortable: false,
        },
      ];
    },
  },
  watch: {
    currentPage() {
      this.getRecepciones();
    },
  },
  created() {
    this.getRecepciones()
  }
}
</script>

<style>

</style>
